﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using Infragistics.DragDrop;
using Microsoft.Practices.Prism.Commands;

namespace InfragisticsDragDrop
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = new Person();
        }

        public ICommand DropCommand
        {
            get { return new DelegateCommand(HandleDropCommand); }
        }

        public ObservableCollection<Person> DroppedPeople { get; set; }

        private void DragSource_OnDragStart(object sender, DragDropStartEventArgs e)
        {
            if (e.OriginalDragSource is TextBlock)
            {
                e.Data = (e.OriginalDragSource as TextBlock);
                e.DragSnapshotElement = e.OriginalDragSource;
            }
            else
            {
                e.Cancel = true;
            }
        }

        private void DragSource_OnDrop(object sender, DropEventArgs e)
        {
            throw new NotImplementedException();
        }

        private void HandleDropCommand()
        {
        }
    }

    public class Person
    {
        public Person()
        {
            DroppedPeople = new ObservableCollection<Person>();
        }

        public ICommand DragStartedCommand
        {
            get { return new DelegateCommand(HandleDragStartedCommand); }
        }

        private void HandleDragStartedCommand()
        {
            throw new NotImplementedException();
        }


        public int Age { get; set; }

        public ObservableCollection<Person> DroppedPeople { get; set; }
        public string Name { get; set; }

        public ObservableCollection<Person> People
        {
            get { return new ObservableCollection<Person>(new List<Person> {new Person {Name = "Max Power", Age = 10}, new Person {Name = "Hank Scorpio", Age = 11}}); }
        }
    }
}